"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Link = void 0;
const JSONTemplate_1 = require("modloader64_api/JSONTemplate");
class Link extends JSONTemplate_1.JSONTemplate {
    emulator;
    state_addr = 0x0;
    pos_addr = 0x803E440C; //0x4
    rotYaw_addr = 0x803F6F1A; //0x2
    rotRoll_addr = 0x803F6F1C; //0x2
    rotPitch_addr = 0x803F6F28; //0x2
    //ABC4FC might be anim data 
    sound_addr = 0x0;
    anim_data_addr = 0x0;
    anim_raw_data_addr = 0x0;
    /*
    803CA8D0,4 - First bitfield of player statuses (PlayerStatus0).
    00010000 - Player is riding the ship. (Checked at 80120484)
    00100000 - Player is swimming.
    803CA8D4,4 - Second bitfield of player statuses (PlayerStatus1).
    00000400 - In ship while it is sailing.
  */
    constructor(emu) {
        super();
        this.emulator = emu;
    }
    get pos() {
        return this.emulator.rdramReadBuffer(0x803E440C, 0xC);
    }
    get rot() {
        return this.emulator.rdramReadBuffer(0x803F6F10, 0x6);
    }
    get matrixData() {
        let linkPointer = this.emulator.rdramRead32(0x803CA410);
        let mpCLModel = this.emulator.rdramRead32(linkPointer + 0x32C);
        let mpNodeMtx = this.emulator.rdramRead32(mpCLModel + 0x8C);
        return this.emulator.rdramReadBuffer(mpNodeMtx, 0x1E60);
    }
}
exports.Link = Link;
//# sourceMappingURL=Link.js.map