/// <reference types="node" />
import { JSONTemplate } from "modloader64_api/JSONTemplate";
import * as API from '../API/Imports';
import IMemory from "modloader64_api/IMemory";
import { IWWCore } from "../API/Imports";
export declare const enum ShieldBitMap {
    HEROES = 0,
    MIRROR = 1
}
export declare const enum SwordBitMap {
    HerosSword = 0,
    MasterSword = 1,
    MasterSwordHalf = 2,
    MasterSwordFull = 3
}
export declare class QuestStatus extends JSONTemplate implements API.IQuestStatus {
    private emulator;
    private songFlags;
    private songFlagsAddr;
    constructor(emu: IMemory, core: IWWCore);
    jsonFields: string[];
    get max_hp(): number;
    set max_hp(flag: number);
    get max_mp(): number;
    set max_mp(flag: number);
    get current_hp(): number;
    set current_hp(flag: number);
    get current_mp(): number;
    set current_mp(flag: number);
    get songs(): Buffer;
    set songs(flag: Buffer);
    get hasTunic(): boolean;
    set hasTunic(flag: boolean);
    get bracelet(): number;
    set bracelet(flag: number);
    get currentWallet(): number;
    set currentWallet(flag: number);
    get pirate_charm(): Buffer;
    set pirate_charm(flag: Buffer);
    get hero_charm(): boolean;
    set hero_charm(flag: boolean);
    private windsRequiemFlag;
    get windsRequiem(): boolean;
    set windsRequiem(bool: boolean);
    private balladGalesFlag;
    get balladGales(): boolean;
    set balladGales(bool: boolean);
    private commandMelodyFlag;
    get commandMelody(): boolean;
    set commandMelody(bool: boolean);
    private earthLyricFlag;
    get earthLyric(): boolean;
    set earthLyric(bool: boolean);
    private windAriaFlag;
    get windAria(): boolean;
    set windAria(bool: boolean);
    private songPassingFlag;
    get songPassing(): boolean;
    set songPassing(bool: boolean);
    get triforce(): Buffer;
    set triforce(flag: Buffer);
    get pearls(): Buffer;
    set pearls(flag: Buffer);
    get owned_charts(): Buffer;
    set owned_charts(flag: Buffer);
    get opened_charts(): Buffer;
    set opened_charts(flag: Buffer);
    get completed_charts(): Buffer;
    set completed_charts(flag: Buffer);
    get sectors(): Buffer;
    set sectors(flag: Buffer);
    get deciphered_triforce(): Buffer;
    set deciphered_triforce(flag: Buffer);
    get tingle_statues(): Buffer;
    set tingle_statues(flag: Buffer);
}
//# sourceMappingURL=QuestStatus.d.ts.map