"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WindWaker = void 0;
const ModLoaderAPIInjector_1 = require("modloader64_api/ModLoaderAPIInjector");
const EventHandler_1 = require("modloader64_api/EventHandler");
const API = __importStar(require("./API/Imports"));
const Imports_1 = require("./src/Imports");
class WindWaker {
    heap_size = -1;
    heap_start = -1;
    header = "GZLE";
    ModLoader = {};
    eventTicks = new Map();
    link;
    save;
    global;
    helper;
    isSaveLoaded = false;
    touching_loading_zone = false;
    last_known_scene = "";
    last_known_room = -1;
    isLinkLoadingZone;
    temp = false;
    preinit() {
        this.eventTicks.set('waitingForSaveload', () => {
            if (!this.isSaveLoaded && this.helper.isSceneNameValid() && !this.helper.isTitleScreen()) {
                this.isSaveLoaded = true;
                EventHandler_1.bus.emit(API.WWEvents.ON_SAVE_LOADED, {});
            }
        });
    }
    init() {
    }
    postinit() {
        this.global = new Imports_1.GlobalContext(this.ModLoader.emulator);
        this.link = new Imports_1.Link(this.ModLoader.emulator);
        this.save = new Imports_1.SaveContext(this.ModLoader.emulator, this);
        this.helper = new Imports_1.WWHelper(this.save, this.global, this.link, this.ModLoader.emulator);
    }
    onTick() {
        if (this.helper.isTitleScreen() || !this.helper.isSceneNameValid())
            return;
        if (this.helper.isLoadingZone() && !this.touching_loading_zone) {
            this.ModLoader.emulator.rdramWrite8(0x81803000, 0);
            EventHandler_1.bus.emit(API.WWEvents.ON_LOADING_ZONE, {});
            this.touching_loading_zone = true;
        }
        if (this.touching_loading_zone && this.helper.isSceneChange() && !this.temp) {
            EventHandler_1.bus.emit(API.WWEvents.ON_SCENE_CHANGE, this.global.next_scene_name);
            this.touching_loading_zone = false;
            this.temp = true;
        }
        if (this.global.current_scene_frame === 60)
            this.temp = false;
        this.eventTicks.forEach((value, key) => {
            value();
        });
        // Room change check
        if (this.last_known_room !== this.global.current_room_number) {
            EventHandler_1.bus.emit(API.WWEvents.ON_ROOM_CHANGE, this.global.current_scene_name, this.global.current_room_number);
            this.last_known_room = this.global.current_room_number;
        }
    }
}
__decorate([
    (0, ModLoaderAPIInjector_1.ModLoaderAPIInject)()
], WindWaker.prototype, "ModLoader", void 0);
exports.WindWaker = WindWaker;
//# sourceMappingURL=WindWaker.js.map