/// <reference types="node" />
import IMemory from 'modloader64_api/IMemory';
import * as API from '../API/Imports';
import { JSONTemplate } from 'modloader64_api/JSONTemplate';
import { InventoryItem } from '../API/Imports';
export declare class Inventory extends JSONTemplate implements API.IInventory {
    private emulator;
    private instance;
    private inventory_bitfield_addr;
    private spoilsBag;
    private baitBag;
    private deliveryBag;
    constructor(emu: IMemory);
    jsonFields: string[];
    get FIELD_TELESCOPE(): boolean;
    set FIELD_TELESCOPE(bool: boolean);
    get FIELD_SAIL(): boolean;
    set FIELD_SAIL(bool: boolean);
    get FIELD_WIND_WAKER(): boolean;
    set FIELD_WIND_WAKER(bool: boolean);
    get FIELD_GRAPPLING_HOOK(): boolean;
    set FIELD_GRAPPLING_HOOK(bool: boolean);
    get FIELD_SPOILS_BAG(): boolean;
    set FIELD_SPOILS_BAG(bool: boolean);
    get FIELD_BOOMERANG(): boolean;
    set FIELD_BOOMERANG(bool: boolean);
    get FIELD_DEKU_LEAF(): boolean;
    set FIELD_DEKU_LEAF(bool: boolean);
    get FIELD_TINGLE_TUNER(): boolean;
    set FIELD_TINGLE_TUNER(bool: boolean);
    get FIELD_PICTO_BOX(): API.InventoryItem;
    set FIELD_PICTO_BOX(item: API.InventoryItem);
    get FIELD_IRON_BOOTS(): boolean;
    set FIELD_IRON_BOOTS(bool: boolean);
    get FIELD_MAGIC_ARMOR(): boolean;
    set FIELD_MAGIC_ARMOR(bool: boolean);
    get FIELD_BAIT_BAG(): boolean;
    set FIELD_BAIT_BAG(bool: boolean);
    get FIELD_BOW(): API.InventoryItem;
    set FIELD_BOW(item: API.InventoryItem);
    get FIELD_BOMBS(): boolean;
    set FIELD_BOMBS(bool: boolean);
    get FIELD_BOTTLE1(): InventoryItem;
    set FIELD_BOTTLE1(content: API.InventoryItem);
    get FIELD_BOTTLE2(): API.InventoryItem;
    set FIELD_BOTTLE2(content: API.InventoryItem);
    get FIELD_BOTTLE3(): API.InventoryItem;
    set FIELD_BOTTLE3(content: API.InventoryItem);
    get FIELD_BOTTLE4(): API.InventoryItem;
    set FIELD_BOTTLE4(content: API.InventoryItem);
    get FIELD_DELIVERY_BAG(): boolean;
    set FIELD_DELIVERY_BAG(bool: boolean);
    get FIELD_HOOKSHOT(): boolean;
    set FIELD_HOOKSHOT(bool: boolean);
    get FIELD_SKULL_HAMMER(): boolean;
    set FIELD_SKULL_HAMMER(bool: boolean);
    get arrowCount(): number;
    set arrowCount(flag: number);
    get bombCount(): number;
    set bombCount(flag: number);
    get rupeeCount(): number;
    set rupeeCount(flag: number);
    get arrowCap(): number;
    set arrowCap(flag: number);
    get bombCap(): number;
    set bombCap(flag: number);
    get rupeeCap(): number;
    set rupeeCap(flag: number);
    get spoils_slots(): Buffer;
    set spoils_slots(flag: Buffer);
    get bait_slots(): Buffer;
    set bait_slots(flag: Buffer);
    get delivery_slots(): Buffer;
    set delivery_slots(flag: Buffer);
    get owned_delivery(): Buffer;
    set owned_delivery(flag: Buffer);
    get owned_spoils(): Buffer;
    set owned_spoils(flag: Buffer);
    get owned_bait(): Buffer;
    set owned_bait(flag: Buffer);
    get count_spoils(): Buffer;
    set count_spoils(flag: Buffer);
    get count_delivery(): Buffer;
    set count_delivery(flag: Buffer);
    get count_bait(): Buffer;
    set count_bait(flag: Buffer);
    get owned_items(): Buffer;
    set owned_items(flag: Buffer);
    getItemInSlot(slotId: number): API.InventoryItem;
    getSlotForItem(item: API.InventoryItem): number;
    setItemInSlot(item: API.InventoryItem, slot: number): void;
}
//# sourceMappingURL=Inventory.d.ts.map