"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaveContext = void 0;
const JSONTemplate_1 = require("modloader64_api/JSONTemplate");
const CORE = __importStar(require("../src/Imports"));
const SwordsEquipment_1 = require("./SwordsEquipment");
const ShieldsEquipment_1 = require("./ShieldsEquipment");
const StageInfo_1 = require("./StageInfo");
class SaveContext extends JSONTemplate_1.JSONTemplate {
    emulator;
    core;
    inventory;
    questStatus;
    swords;
    shields;
    stage_Live;
    stage0_Sea;
    stage1_SeaAlt;
    stage2_ForsakenFortress;
    stage3_DRC;
    stage4_FW;
    stage5_TOTG;
    stage6_ET;
    stage7_WT;
    stage8_GT;
    stage9_Hyrule;
    stageA_ShipInt;
    stageB_HouseMisc;
    stageC_CaveInt;
    stageD_CaveShip;
    stageE_BlueChu;
    stageF_TestMaps;
    jsonFields = [
        "inventory",
        "questStatus",
        "swords",
        "shields",
        "eventFlags",
        "stage_Live",
        "stage0_Sea",
        "stage1_SeaAlt",
        "stage2_ForsakenFortress",
        "stage3_DRC",
        "stage4_FW",
        "stage5_TOTG",
        "stage6_ET",
        "stage7_WT",
        "stage8_GT",
        "stage9_Hyrule",
        "stageA_ShipInt",
        "stageB_HouseMisc",
        "stageC_CaveInt",
        "stageD_CaveShip",
        "stageE_BlueChu",
        "stageF_TestMaps",
    ];
    constructor(emu, core) {
        super();
        this.emulator = emu;
        this.core = core;
        this.inventory = new CORE.Inventory(emu);
        this.questStatus = new CORE.QuestStatus(emu, core);
        this.swords = new SwordsEquipment_1.SwordsEquipment(emu, core);
        this.shields = new ShieldsEquipment_1.ShieldsEquipment(emu, core);
        this.stage_Live = new StageInfo_1.StageInfo(emu, 0x0, 0x803C5380);
        this.stage0_Sea = new StageInfo_1.StageInfo(emu, 0x0);
        this.stage1_SeaAlt = new StageInfo_1.StageInfo(emu, 0x1);
        this.stage2_ForsakenFortress = new StageInfo_1.StageInfo(emu, 0x2);
        this.stage3_DRC = new StageInfo_1.StageInfo(emu, 0x3);
        this.stage4_FW = new StageInfo_1.StageInfo(emu, 0x4);
        this.stage5_TOTG = new StageInfo_1.StageInfo(emu, 0x5);
        this.stage6_ET = new StageInfo_1.StageInfo(emu, 0x6);
        this.stage7_WT = new StageInfo_1.StageInfo(emu, 0x7);
        this.stage8_GT = new StageInfo_1.StageInfo(emu, 0x8);
        this.stage9_Hyrule = new StageInfo_1.StageInfo(emu, 0x9);
        this.stageA_ShipInt = new StageInfo_1.StageInfo(emu, 0xA);
        this.stageB_HouseMisc = new StageInfo_1.StageInfo(emu, 0xB);
        this.stageC_CaveInt = new StageInfo_1.StageInfo(emu, 0xC);
        this.stageD_CaveShip = new StageInfo_1.StageInfo(emu, 0xD);
        this.stageE_BlueChu = new StageInfo_1.StageInfo(emu, 0xE);
        this.stageF_TestMaps = new StageInfo_1.StageInfo(emu, 0xF);
    }
    get eventFlags() {
        return this.emulator.rdramReadBuffer(0x803C522C, 0x100);
    }
    set eventFlags(flag) {
        this.emulator.rdramWriteBuffer(0x803C522C, flag);
    }
}
exports.SaveContext = SaveContext;
//# sourceMappingURL=SaveContext.js.map