"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WWHelper = void 0;
const JSONTemplate_1 = require("modloader64_api/JSONTemplate");
class WWHelper extends JSONTemplate_1.JSONTemplate {
    save;
    global;
    link;
    emu;
    constructor(save, global, link, memory) {
        super();
        this.save = save;
        this.global = global;
        this.link = link;
        this.emu = memory;
    }
    isLinkControllable() {
        // Old Check
        //let r1 = this.emu.rdramRead16(0x803C9EB8);
        //let r2 = this.emu.rdramRead8(0x803CA783);
        //return (r1) === 0xFFFF && (r2) > 0x0 && !this.isSceneChange();
        let r1 = this.emu.rdramRead8(0x803F6A89);
        return (r1 === 0xFF);
    }
    isTitleScreen() {
        //if (!this.isSceneNameValid()) return false;
        //let value1 = this.emu.rdramRead32(0x803C9D3C);
        //let value2 = this.emu.rdramRead32(0x803C9D3C + 0x4);
        //7365615f 54000000 = sea_T 
        //4e616d65 = Name 
        //return (value1 === 0x7365615F && value2 === 0x54000000) || (value1 === 0x4E616D65 && value2 === 0)
        return (this.global.current_scene_name === "sea_T");
    }
    isSceneChange() {
        let r1 = this.global.current_scene_frame;
        return (r1 === 0x00000000);
    }
    isLoadingZone() {
        let r1 = this.emu.rdramRead8(0x81803000);
        return (r1 === 0x1);
    }
    isLinkExists() {
        return (this.global.linkPointer !== 0x0);
    }
    isSceneNameValid() {
        return this.global.current_scene_name !== "NULL" && !this.isTitleScreen();
    }
    isPaused() {
        return this.emu.rdramRead8(0x803F7097) !== 0x0;
    }
}
exports.WWHelper = WWHelper;
//# sourceMappingURL=WWHelper.js.map